/*
 * Nomad Instrument Control Software
 *
 * Copyright 2011 Institut Laue-Langevin
 *
 * Licensed under the EUPL, Version 1.1 only (the "License");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 *
 * http://joinup.ec.europa.eu/software/page/eupl
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 */

/*!
 * \brief  Cyclops Parser implementation
 * \author Locatelli
 */

#ifndef CYCLOPSPARSER_H
#define CYCLOPSPARSER_H

#include "controllers/dif/common/commandline/DiffParser.h"

namespace cyclops {

/**
 * Class overloading DiffParser.
 */
class CyclopsParser : public dif::DiffParser {

public:
	//! Controller type value
	static const std::string TYPE;

	/**
	 * Constructor.
	 */
	CyclopsParser();

	/**
	 * Destructor.
	 */
	virtual ~CyclopsParser();

	/**
	 * Decode the command line.
	 * throws BadInput
	 */
	virtual bool decode(Items items) throw (CommonCmdDef::BadInput);
};

}

#endif
