/*
 * HistoEAEDetectorElement.cpp
 *
 *  Created on: Mar 30, 2016
 *      Author: acq
 */
#include "ETotDetectorElement.h"
using namespace std;

namespace npp {

const string ETotDetectorElement::TYPE = "etot_detector_element";

/*
 * Constructor
 */
ETotDetectorElement::ETotDetectorElement(const string& name) : acquisition::DetectorElement(name) {

	registerFunction(TYPE);

	m_Driver.init(this, "driver");
}

/*
 * Destructor
 */
ETotDetectorElement::~ETotDetectorElement() {

}

/*
 * postConfiguration
 */
void ETotDetectorElement::postConfiguration() {

	acquisition::DetectorElement::postConfiguration();
	registerUpdater(m_Driver->histo_e_de, &ETotDetectorElement::updateData, this);
}

/*
 * updateData
 */
void ETotDetectorElement::updateData() {

	detSize = m_Driver->histo_e_de.getSize();
	int32* ldata =  m_Driver->histo_e_de();
	data.update(ldata);
	data.setSize(detSize());
	data.sendEvent();
	calculateDetectorSum();
}

}



