/*
 * Nomad Instrument Control Software
 *
 * Copyright 2011 Institut Laue-Langevin
 *
 * Licensed under the EUPL, Version 1.1 only (the "License");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 *
 * http://joinup.ec.europa.eu/software/page/eupl
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 */

#ifndef NPP_REMOTEDPPTEST_H
#define NPP_REMOTEDPPTEST_H

#include "RemoteDPPLiveProcess.h"
#include <boost/thread.hpp>
#include <stdint.h>
#include <memory>
#include <fstream>

namespace npp {

class RemoteDPPTest : public RemoteDPPLiveProcess {

public:
	//! Type of controller
	static const std::string TYPE;

	RemoteDPPTest(const std::string& name);
	RemoteDPPTest(const RemoteDPPTest& controller);
	virtual ~RemoteDPPTest();

	virtual void postConfiguration();
	virtual void setDetectorControllers(const std::vector<ControllerPtr<acquisition::DetectorController> > & detectorControllers);

	virtual void start();
	virtual void stop();
	virtual void raz();

	void updateListModeData(int index);

private:
	void resetData();

	Property<int32> maxBlock;
	Property<int32> refreshTimeS;

	std::ofstream m_file;
};

}

#endif
